﻿init python:
    import pygame
    import random
    import time
    random.seed(time.perf_counter_ns())
    def distance(x, y):
        if x >= y:
            result = x - y
        else:
            result = y - x
        return result

    class runner_woman(renpy.Displayable):
        def __init__(self, image, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = 1000
            self.y = 0
            self.parent = parent
            self.counted = False
        def render(self,width,height,st,at):
            self.x -= self.parent.speed
            if self.x < -1000:
                try:
                    self.parent.women.remove(self)
                except:
                    pass
            
            t = Transform(self.image, xanchor=0.5, yanchor=0.5, zoom = 8, nearest = True)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            renpy.redraw(self, 0)

            return rv
    class runner_class(renpy.Displayable):
        def __init__(self, images, jump_image, women_list):
            super(renpy.Displayable,self).__init__()
            self.images = images
            self.jump_image = jump_image
            self.women_list = women_list
            self.women = []
            self.speed = 6
            self.score = 0
            self.x = 0
            self.y = 0
            self.y_velocity = 0
            self.image_index = 0
            self.caught = None
            self.stage = "intro"
            self.flip = 1
        def restart(self):
            self.women = []
            self.speed = 6
            self.score = 0
            self.x = 0
            self.y = 0
            self.y_velocity = 0
            self.image_index = 0
            self.caught = None
            self.stage = "running"
        def add(self, woman, x = 1000, counted = False):
            w = runner_woman(woman, self)
            w.x = x
            w.counted = counted
            self.women.append(w)
            
        def jump(self):
            if self.y == 0:
                self.y_velocity = -20
                renpy.play("runner/jump.ogg", "sound")
        def run(self):
            self.image_index += 1
            if self.image_index > 1:
                self.image_index = 0
        def spawn(self):
            if len(self.women) < 10:
                woman = random.choice(self.women_list)
                for i in self.women:
                    if i.image == woman:
                        self.spawn()
                        break
                else:
                    self.women.append(runner_woman(woman, self))

        def render(self,width,height,st,at):
            if not self.caught:
                self.y += self.y_velocity
                if self.y < 0:
                    self.y_velocity += 1
                    img = self.jump_image
                else:
                    self.y_velocity = 0
                    img = self.images[self.image_index]
                for i in self.women:
                    if -60 < i.x < 60:
                        if self.y > -100:
                            self.caught = i
                            renpy.play("runner/lose.ogg", "sound")
                    if not i.counted:
                        if i.x < 0:
                            i.counted = True
                            self.score += 1
                            if not self.score%10:
                                self.speed += 1
                                renpy.play("runner/level up.ogg", "sound")

            else:
                self.speed = 0
                img = self.jump_image
            t = Transform(img, xanchor=0.5, yanchor=0.5, zoom = 8, nearest = True, xzoom = self.flip)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            renpy.redraw(self, 0)

            return rv
init:
    image runner_idle = Crop((0, 0, 16, 16), "runner/runner.png")
    image runner_jump = Crop((16, 0, 16, 16), "runner/runner.png")
    image runner_run_1 = Crop((32, 0, 16, 16), "runner/runner.png")
    image runner_run_2 = Crop((48, 0, 16, 16), "runner/runner.png")

    image runner_woman_1 = Crop((0, 16, 16, 16), "runner/runner.png")
    image runner_woman_2 = Crop((16, 16, 16, 16), "runner/runner.png")
    image runner_woman_3 = Crop((32, 16, 16, 16), "runner/runner.png")
    image runner_woman_4 = Crop((48, 16, 16, 16), "runner/runner.png")

    image runner_woman_5 = Crop((0, 32, 16, 16), "runner/runner.png")
    image runner_woman_6 = Crop((16, 32, 16, 16), "runner/runner.png")
    image runner_woman_7 = Crop((32, 32, 16, 16), "runner/runner.png")
    image runner_woman_8 = Crop((48, 32, 16, 16), "runner/runner.png")

    image runner_woman_9 = Crop((0, 48, 16, 16), "runner/runner.png")
    image runner_woman_10 = Crop((16, 48, 16, 16), "runner/runner.png")
    image runner_woman_11 = Crop((32, 48, 16, 16), "runner/runner.png")
    image runner_woman_12 = Crop((48, 48, 16, 16), "runner/runner.png")

    image runner_woman_13 = Crop((0, 64, 16, 16), "runner/runner.png")
    image runner_woman_14 = Crop((16, 64, 16, 16), "runner/runner.png")
    image runner_woman_15 = Crop((32, 64, 16, 16), "runner/runner.png")
    image runner_woman_16 = Crop((48, 64, 16, 16), "runner/runner.png")

    image runner_priest = Crop((0, 112, 16, 16), "runner/runner.png")
default runner_instance = runner_class(
    [
        "runner_run_1",
        "runner_run_2",
    ],
    "runner_idle",
    [
        "runner_woman_1",
        "runner_woman_2",
        "runner_woman_3",
        "runner_woman_4",
        "runner_woman_5",
        "runner_woman_6",
        "runner_woman_7",
        "runner_woman_8",
        "runner_woman_9",
        "runner_woman_10",
        "runner_woman_11",
        "runner_woman_12",
        "runner_woman_13",
        "runner_woman_14",
        "runner_woman_15",
        "runner_woman_16",
    ]
)
screen runner_screen(g = runner_instance):
    # modal True
    add "#9ff"
    add "#6a645d" ysize 500 yalign 1.0
    key "K_SPACE" action Function(g.jump)
    for i in g.women:
        add i align .5,.5
    add g align .5,.5
    if g.stage == "running":
        if not g.caught:
            timer .1 repeat True action Function(g.run)
            timer (random.random()*3)+1 repeat True action Function(g.spawn)
        else:
            hbox spacing 10 align .5,.9:
                button:
                    background "#362525" padding 10,10
                    text "Retry"
                    action Function(g.restart)
                button:
                    background "#362525" padding 10,10
                    text "Give in"
                    action Return(g.caught)
        vbox align .5,.8:
            text f"Dodged: {g.score}" align .5,.5
            text f"Speed: {g.speed}" align .5,.5

transform zoom(z, n = False):
    nearest n
    zoom z

transform zoom2(z):
    nearest True
    zoom z align (.5,.5)

default ted = Character("Father ted")
default dan = Character("Daniel")

label runner_example:
    # let's add our priest
    $ runner_instance.add("runner_priest", -300, True)
    $ runner_instance.flip = -1
    # and halt the speed
    $ runner_instance.speed = 0
    show screen runner_screen
    ted "Son... It's time for you to get married."
    dan "Never! Father."
    $ runner_instance.flip = 1
    dan "I'm a free spirit!"
    $ runner_instance.stage = "running"
    $ runner_instance.speed = 6
    call screen runner_screen
    $ w = _return.image
    show image "[w]" at zoom2(16)
    "Congratulations"


